// Pixie.cpp : AvP[Vp̃Gg |Cg̒`
//

#include "stdafx.h"
#include "resource.h"
#include <commctrl.h>
#include <commdlg.h>

#define DLG_WIDTH		240

// gsGetFile.dll ̊֐錾
BOOL gsGetOpenFileName(OPENFILENAME* pofn);
BOOL gsGetSaveFileName(OPENFILENAME* pofn);

// winlist.cpp
HWND GetNextTopWindow(void);
BOOL CALLBACK WinlistDlgFunc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);

// DlgBrackets.cpp
LRESULT CALLBACK DlgBrackets(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
BOOL ReadFileFreeWord(HWND hWnd, LPTSTR szFileName);

HINSTANCE			g_hInst;					// The current instance
HWND				hWndMain;
HWND				hWndEdit = 0;

static TCHAR			szIniName[256] = _T("Pixie.ini");

struct DLGITEM_T {
	int id;
	int left;
	int top;
	int right;
	int bottom;
};
static int iDlgItemId[] = {
	IDC_EDIT1,
	IDC_BUTTON1,
	IDC_BUTTON6,
	IDC_BUTTON2,
	IDC_BUTTON7,
	IDC_BUTTON3,
	IDC_BUTTON5,
	IDC_BUTTON4,
	IDC_BUTTON8,
	-1
};

static int iState2 = -1;

static TCHAR szSendText[1024];

static DWORD dwOptions = 0;
#define OPT_NEWKEYMACRO		0x00000001UL

////////////////////////////////////////////////////////////////////////////

// Nbv{[hւ̐ݒ
BOOL DoSetClipboard(HWND hWnd, TCHAR szStr[])
{
	HLOCAL hGMem;
	LPTSTR ptr;

	if (OpenClipboard(hWnd)) {
		EmptyClipboard();
		hGMem = LocalAlloc(LMEM_FIXED, 3000);
		ptr = (LPTSTR)hGMem;
		wcscpy(ptr, szStr);
		SetClipboardData(CF_UNICODETEXT, hGMem);
		CloseClipboard();
	}

	return TRUE;			
}

// gsGetFile.dllgpt@CI[v
BOOL GetOpenFileNameEx(OPENFILENAME* pofn)
{
	HINSTANCE hInst = LoadLibrary(TEXT("gsgetfile.dll"));
	if (hInst) {
		BOOL (*gsGetOpenFileName)(OPENFILENAME* pofn);
		(FARPROC&)gsGetOpenFileName = GetProcAddress(hInst, TEXT("gsGetOpenFileName"));
		if (gsGetOpenFileName) {
			BOOL ret = gsGetOpenFileName(pofn);
			FreeLibrary(hInst);
			return ret;
		}
		FreeLibrary(hInst);
	}
	return GetOpenFileName(pofn);
}

//
INT DoGetFileName(HWND hWnd, LPTSTR szFileName, INT nMax, LPTSTR szOpenFilter)
{
    OPENFILENAME of;

    memset(&of, 0, sizeof(of));				// Initial file open structure

    of.lStructSize = sizeof(of);
    of.hwndOwner   = hWnd;
    of.lpstrFile   = szFileName;
    of.nMaxFile    = nMax;
    of.lpstrFilter = szOpenFilter;
    of.Flags       = 0;

    //if (GetOpenFileName(&of)) {
    if (GetOpenFileNameEx(&of)) {
        return lstrlen(szFileName);
    } else {
        return 0;
	}
}

// tpX}
int SelectFullpath(HWND hWnd)
{
	TCHAR szFname[MAX_PATH] = TEXT("");
	if (DoGetFileName(hWnd, szFname, MAX_PATH, TEXT("ׂẴt@C (*.*)\0*.*"))) {
		DoSetClipboard(hWnd, szFname);
		SendMessage(hWndEdit, WM_PASTE, 0, 0);
	}
	return 0;
}

// ̑荞
int PixSendStrings(HWND hWnd)
{
	TCHAR code[3];
	TCHAR *pr;
	TCHAR *pw;

	pr = pw = szSendText;
	while (*pr) {
		if (*pr == _T('\\')) {
			pr++;
			if (*pr == 0) break;
			switch (*pr) {
			case _T('x'):
				pr++;
				code[0] = *pr++;
				code[1] = *pr;
				code[2] = _T('\0');
				*pw   = (TCHAR)wcstoul(code, NULL, 16);
				break;
			case _T('n'):
				*pw   = VK_RETURN;
				break;
			case _T('L'):
				*pw = VK_LEFT;
				break;
			case _T('U'):
				*pw = VK_UP;
				break;
			case _T('R'):
				*pw = VK_RIGHT;
				break;
			case _T('D'):
				*pw = VK_DOWN;
				break;
			case _T('W'):
				*pw++ = -1;
				*pw = -1;
				break;
			case _T('C'):				// CTRL
				*pw = VK_CONTROL;
				break;
			case _T('S'):				// SHIFT
				*pw = VK_SHIFT;
				break;
			case _T('A'):				// ALT
				*pw = VK_MENU;
				break;
			}
		} else if (iswlower(*pr)) {
			*pw = toupper(*pr);
		} else if (pw != pr) {
			*pw = *pr;
		}
		pr++;
		pw++;
	}
	*pw = 0;
	if (dwOptions & OPT_NEWKEYMACRO) {
		DoSetClipboard(hWnd, szSendText);
		SendMessage(hWndEdit, WM_SETTEXT, 0, (LPARAM)"");
	}
	return 0;
}

// 
void StInitialize(void)
{
	// sW[̃tpX̎擾
	LPTSTR p;
	DWORD dwRet = GetModuleFileName(NULL, szIniName, sizeof(szIniName));
	if (dwRet) {
		p = wcsrchr(szIniName, _T('.'));
		*p = 0;
		wcscat(szIniName, _T(".dat"));
	}
	ReadFileFreeWord(hWndMain, szIniName);
}

// GfBbgRg[
#if 0
WNDPROC OldProc;
LRESULT CALLBACK PteEditProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message) {
	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		case IDOK:
			//SendMessage(hWndMain, message, wParam, lParam);
			{
				TCHAR s[256];
				wsprintf(s, _T("OK %04X"), wParam);
				SendMessage(hWndEdit, WM_SETTEXT, 0, (LPARAM)s);
				SetFocus(hWndEdit);
			}
			break;
		}
		break;

	case WM_KEYUP:
		{
			TCHAR s[256];
			wsprintf(s, _T("%04X"), wParam);
			SendMessage(hWndEdit, WM_SETTEXT, 0, (LPARAM)s);
			SetFocus(hWndEdit);
		}
		break;
	}
	return CallWindowProc(OldProc, hWnd, message, wParam, lParam);
}
#endif

// WM_INITDIALOG
BOOL DoInitDialog(HWND hDlg)
{
	hWndMain = hDlg;
	hWndEdit = GetDlgItem(hDlg, IDC_EDIT1);

	// X[ACR̓o^
	HICON hIcon = (HICON)SendMessage(hDlg, WM_GETICON, 0, 0);
	if (hIcon == 0) {
		hIcon = (HICON)LoadImage(g_hInst, MAKEINTRESOURCE(IDI_ICON1),
					IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR);
		SendMessage(hDlg, WM_SETICON, FALSE, (LPARAM)hIcon);
	}

	// GfBbgRg[̃TuNX
	//OldProc = (WNDPROC)SetWindowLong(hWndEdit, GWL_WNDPROC, (LONG)PteEditProc);

	RECT rt, rt1;
	int DlgWidth, DlgHeight;	// sNZPʂł̃_CAO̕ƍ
	int i, x, y, w, h;
	HWND hWndItem;

	if (GetWindowRect(hDlg, &rt1)) {
		SystemParametersInfo(SPI_GETWORKAREA, 0, &rt, sizeof(rt));
		DlgWidth	= rt.right - rt.left - 1;
		if (DlgWidth > DLG_WIDTH) {
			DlgWidth = DLG_WIDTH;
		}
		DlgHeight	= rt1.bottom - rt1.top;
		SetWindowPos(hDlg, HWND_TOPMOST, 0, 0, DlgWidth, DlgHeight, SWP_NOMOVE);
		//{
		//	TCHAR str[256];
		//	wsprintf(str, _T("%d,%d"), DlgWidth, DlgHeight);
		//	MessageBox(hDlg, str, _T("debug"), MB_OK);
		//}

		GetClientRect(hDlg, &rt1);

		hWndItem = GetDlgItem(hDlg, iDlgItemId[1]);
		GetClientRect(hWndItem, &rt);
		w = rt.right  - rt.left;
		h = rt.bottom - rt.top;
		x = rt1.right - w - 2;
		y = rt1.top + 1;
		SetWindowPos(hWndItem, 0, x, y, w, h, SWP_NOZORDER | SWP_NOSIZE);

		for (i=2; iDlgItemId[i] != -1; i++) {
			hWndItem = GetDlgItem(hDlg, iDlgItemId[i]);
			GetClientRect(hWndItem, &rt);
			w = rt.right  - rt.left;
			h = rt.bottom - rt.top;
			x = rt1.right - w*i - 4;
			y = rt1.top + 1;
			SetWindowPos(hWndItem, 0, x, y, w, h, SWP_NOZORDER | SWP_NOSIZE);
		}

		x = rt1.left;
		y = rt1.top + (rt.bottom - rt.top) + 2;		// Ō̃{^̍𗘗p
		GetClientRect(hWndEdit, &rt);
		w = rt1.right - rt1.left - 1;
		h = rt.bottom - rt.top;
		SetWindowPos(hWndEdit, 0, x, y, w, h, SWP_NOZORDER);

	} else {
		SetWindowPos(hDlg, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE);
	}
	ShowWindow(hDlg, SW_SHOW);
	SetFocus(hWndEdit);

	StInitialize();

	return TRUE; 
}

//
int PixSendKey()
{
	UINT flag;

	flag = 0;
	for (TCHAR *p = szSendText; *p != 0; p++) {
		switch (*p) {
		case -1:
			// nop
			break;
		case VK_CONTROL:
			if (flag & 0x00000001UL) {
				keybd_event((BYTE)*p, 0, KEYEVENTF_KEYUP | KEYEVENTF_SILENT, 0);
			} else {
				keybd_event((BYTE)*p, 0, KEYEVENTF_SILENT, 0);
			}
			flag ^= 0x00000001UL;
			break;
		case VK_SHIFT:
			if (flag & 0x00000002UL) {
				keybd_event((BYTE)*p, 0, KEYEVENTF_KEYUP | KEYEVENTF_SILENT, 0);
			} else {
				keybd_event((BYTE)*p, 0, KEYEVENTF_SILENT, 0);
			}
			flag ^= 0x00000002UL;
			break;
		case VK_MENU:
			if (flag & 0x00000004UL) {
				keybd_event((BYTE)*p, 0, KEYEVENTF_KEYUP | KEYEVENTF_SILENT, 0);
			} else {
				keybd_event((BYTE)*p, 0, KEYEVENTF_SILENT, 0);
			}
			flag ^= 0x00000004UL;
			break;
		default:
			keybd_event((BYTE)*p, 0, KEYEVENTF_SILENT, 0);
			keybd_event((BYTE)*p, 0, KEYEVENTF_KEYUP | KEYEVENTF_SILENT, 0);
			break;
		}
		Sleep(250);
	}
	if (flag & 0x0001) {
		keybd_event(VK_CONTROL, 0, KEYEVENTF_KEYUP | KEYEVENTF_SILENT, 0);
	}
	if (flag & 0x0002) {
		keybd_event(VK_SHIFT, 0, KEYEVENTF_KEYUP | KEYEVENTF_SILENT, 0);
	}
	if (flag & 0x0004) {
		keybd_event(VK_MENU, 0, KEYEVENTF_KEYUP | KEYEVENTF_SILENT, 0);
	}
	return 0;
}

// WM_TIMER
BOOL DoTimer(HWND hWnd, WPARAM wParam)
{
	KillTimer(hWnd, wParam);

	switch (wParam) {
	case 1:
		break;

	case 2:

		switch (iState2) {
		case 0x0200:
			SetWindowPos(hWnd, HWND_BOTTOM, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE | SWP_HIDEWINDOW);
			SetTimer(hWnd, 2, 250, NULL);
			iState2++;
			break;
		case 0x0201:
			PixSendKey();
			SetTimer(hWnd, 2, 100, NULL);
			iState2++;
			break;
		case 0x0202:
			SetForegroundWindow(hWnd);
			SetWindowPos(hWnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE | SWP_SHOWWINDOW);
			UpdateWindow(hWnd);
			if (dwOptions & OPT_NEWKEYMACRO) {
				dwOptions &= ~OPT_NEWKEYMACRO;
				SetFocus(hWnd);
			}
			iState2 = -1;
			break;

		case 0x0100:
		case 0x0300:
			SetWindowPos(hWnd, HWND_BOTTOM, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE | SWP_HIDEWINDOW);
			SetTimer(hWnd, 2, 250, NULL);
			iState2++;
			break;
		case 0x0101:
		case 0x0301:
			keybd_event(VK_CONTROL, 0, KEYEVENTF_SILENT, 0);
			keybd_event(0x0056, 0, KEYEVENTF_SILENT, 0);
			keybd_event(0x0056, 0, KEYEVENTF_KEYUP | KEYEVENTF_SILENT, 0);
			keybd_event(VK_CONTROL, 0, KEYEVENTF_KEYUP | KEYEVENTF_SILENT, 0);
			SetTimer(hWnd, 2, 250, NULL);
			iState2++;
			break;
		case 0x0102:
		case 0x0302:
			SendMessage(hWndEdit, WM_SETTEXT, 0, (LPARAM)"");
			SetTimer(hWnd, 2, 100, NULL);
			iState2++;
			break;
		case 0x0303:
			SetForegroundWindow(hWnd);
			SetWindowPos(hWnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE | SWP_SHOWWINDOW);
			UpdateWindow(hWnd);
			SetFocus(hWnd);
			iState2 = -1;
			break;
		case 0x0103:
			SendMessage(hWnd, WM_COMMAND, IDCANCEL, (LPARAM)0);
			iState2 = -1;
			break;
		}
		break;
	}

	return TRUE;
}

// Mesage handler for the About box.
BOOL CALLBACK DlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	static int iX = 0;
	static int iY = 32;
	static BOOL flag = FALSE;
	static RECT drc = {0,0,0,0};
	POINT pt;


	switch (message)
	{
		case WM_INITDIALOG:
			return DoInitDialog(hDlg);

		case WM_SIZE:
			return TRUE; 

		case WM_CLOSE:
			//(WNDPROC)SetWindowLong(hWndEdit, GWL_WNDPROC, (LONG)OldProc);
			break;

		case WM_LBUTTONDOWN:
			if (!flag) {
				GetWindowRect(hDlg, &drc);
				iX = LOWORD(lParam);
				iY = HIWORD(lParam);
				SetCapture(hDlg);
				flag = TRUE;
				return TRUE; 
			}
			break;

		case WM_MOUSEMOVE:
			{
				static int ff = 0;
				ff = 1 - ff; if (ff) break;				// Ԉ
			}
			if (flag) {
				pt.x = (short)LOWORD(lParam) - iX;
				pt.y = (short)HIWORD(lParam) - iY;		// 2̕␔̒l̂shortɃLXg
				ClientToScreen(hDlg, &pt);
				if (pt.x < 0) pt.x = 0;
				if (pt.y < 0) pt.y = 0;
				SetWindowPos(hDlg, HWND_TOPMOST, pt.x, pt.y, 0, 0, SWP_NOSIZE);
				return TRUE;
			}
			break;

		case WM_LBUTTONUP:
			if (flag) {
				pt.x = (short)LOWORD(lParam) - iX;
				pt.y = (short)HIWORD(lParam) - iY;
				ClientToScreen(hDlg, &pt);
				if (pt.x < 0) pt.x = 0;
				if (pt.y < 0) pt.y = 0;
				SetWindowPos(hDlg, HWND_TOPMOST, pt.x, pt.y, 0, 0, SWP_NOSIZE);
				flag = FALSE;
				ReleaseCapture();
				return TRUE;
			}
			break;

		case WM_SETFOCUS:
			SetFocus(hWndEdit);
			return TRUE; 

		case WM_TIMER:
			DoTimer(hDlg, wParam);
			break;

		case WM_COMMAND:
			switch (LOWORD(wParam)) {
			case IDCANCEL:
			case IDC_BUTTON1:
				EndDialog(hDlg, LOWORD(wParam));
				return TRUE;
			case IDOK:
				SendMessage(GetDlgItem(hDlg, IDC_EDIT1), EM_SETSEL, 0, -1);
				SendMessage(GetDlgItem(hDlg, IDC_EDIT1), WM_COPY, 0, 0);
				iState2 = 0x0100;
				SetTimer(hDlg, 2, 100, NULL);
				return TRUE;
			case IDC_BUTTON2:
				SendMessage(hWndEdit, WM_GETTEXT, sizeof(szSendText)/sizeof(TCHAR), (LPARAM)szSendText);
				dwOptions |= OPT_NEWKEYMACRO;
				// Ďs
			case IDC_BUTTON8:
				PixSendStrings(hDlg);
				iState2 = 0x0200;
				SetTimer(hDlg, 2, 100, NULL);
				return TRUE;
			case IDC_BUTTON6:
				SendMessage(GetDlgItem(hDlg, IDC_EDIT1), EM_SETSEL, 0, -1);
				SendMessage(GetDlgItem(hDlg, IDC_EDIT1), WM_COPY, 0, 0);
				iState2 = 0x0300;
				SetTimer(hDlg, 2, 100, NULL);
				return TRUE;
			case IDC_BUTTON7:
				SetWindowPos(hDlg, HWND_TOP, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE | SWP_HIDEWINDOW);
				DialogBox(g_hInst, MAKEINTRESOURCE(IDD_DIALOG_BRACKETS), NULL, (DLGPROC)DlgBrackets);
				SetForegroundWindow(hDlg);
				SetWindowPos(hDlg, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE | SWP_SHOWWINDOW);
				UpdateWindow(hDlg);
				SetFocus(hDlg);
				return TRUE;
			case IDC_BUTTON3:
				SelectFullpath(hDlg);
				SetFocus(hWndEdit);
				return TRUE;
			case IDC_BUTTON5:
				SetWindowPos(hDlg, HWND_TOP, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE | SWP_HIDEWINDOW);
				DialogBox(g_hInst, MAKEINTRESOURCE(IDD_DIALOG_WINLIST), NULL, (DLGPROC)WinlistDlgFunc);
				SetWindowPos(hDlg, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE | SWP_SHOWWINDOW);
				UpdateWindow(hDlg);
				SetFocus(hWndEdit);
				return TRUE;
			case IDC_BUTTON4:
				SendMessage(hWndEdit, WM_SETTEXT, 0, (LPARAM)"");
				SetFocus(hWndEdit);
				return TRUE;
			case IDC_STATIC1:
				return TRUE;
			}
			break;
	}
    return FALSE;
}

int WINAPI WinMain(	HINSTANCE hInstance,
					HINSTANCE hPrevInstance,
					LPTSTR    lpCmdLine,
					int       nCmdShow)
{
 	// TODO: ̈ʒuɃR[hLqĂB
	g_hInst = hInstance;
	DialogBox(hInstance, MAKEINTRESOURCE(IDD_DIALOG1), NULL, (DLGPROC)DlgProc);

	return 0;
}
